// Code generated by gopkg.in/reform.v1. DO NOT EDIT.

package db

import (
	"fmt"
	"strings"

	"gopkg.in/reform.v1"
	"gopkg.in/reform.v1/parse"
)

type requestViewType struct {
	s parse.StructInfo
	z []interface{}
}

// Schema returns a schema name in SQL database ("").
func (v *requestViewType) Schema() string {
	return v.s.SQLSchema
}

// Name returns a view or table name in SQL database ("request").
func (v *requestViewType) Name() string {
	return v.s.SQLName
}

// Columns returns a new slice of column names for that view or table in SQL database.
func (v *requestViewType) Columns() []string {
	return []string{"id", "wallet_id", "purse_id", "type", "status", "source", "amount", "bonus", "turnover", "use_coupon", "coupon_id", "use_rate", "rate_id", "ga_cid", "ip_addr", "ip_country", "gateway", "created", "updated"}
}

// NewStruct makes a new struct for that view or table.
func (v *requestViewType) NewStruct() reform.Struct {
	return new(Request)
}

// RequestView represents request view or table in SQL database.
var RequestView = &requestViewType{
	s: parse.StructInfo{Type: "Request", SQLSchema: "", SQLName: "request", Fields: []parse.FieldInfo{{Name: "Id", Type: "int64", Column: "id"}, {Name: "WalletId", Type: "int64", Column: "wallet_id"}, {Name: "PurseId", Type: "*int64", Column: "purse_id"}, {Name: "Type", Type: "protobufWallet.RequestType", Column: "type"}, {Name: "Status", Type: "protobufWallet.RequestStatus", Column: "status"}, {Name: "Source", Type: "protobufWallet.RequestSource", Column: "source"}, {Name: "Amount", Type: "float64", Column: "amount"}, {Name: "Bonus", Type: "*float64", Column: "bonus"}, {Name: "Turnover", Type: "*float64", Column: "turnover"}, {Name: "UseCoupon", Type: "*bool", Column: "use_coupon"}, {Name: "CouponId", Type: "*int64", Column: "coupon_id"}, {Name: "UseRate", Type: "*bool", Column: "use_rate"}, {Name: "RateId", Type: "*int64", Column: "rate_id"}, {Name: "GaCid", Type: "*string", Column: "ga_cid"}, {Name: "IpAddr", Type: "*string", Column: "ip_addr"}, {Name: "IpCountry", Type: "protobufMain.Country", Column: "ip_country"}, {Name: "Gateway", Type: "protobufWallet.Gateway", Column: "gateway"}, {Name: "Created", Type: "*time.Time", Column: "created"}, {Name: "Updated", Type: "*time.Time", Column: "updated"}}, PKFieldIndex: -1},
	z: new(Request).Values(),
}

// String returns a string representation of this struct or record.
func (s Request) String() string {
	res := make([]string, 19)
	res[0] = "Id: " + reform.Inspect(s.Id, true)
	res[1] = "WalletId: " + reform.Inspect(s.WalletId, true)
	res[2] = "PurseId: " + reform.Inspect(s.PurseId, true)
	res[3] = "Type: " + reform.Inspect(s.Type, true)
	res[4] = "Status: " + reform.Inspect(s.Status, true)
	res[5] = "Source: " + reform.Inspect(s.Source, true)
	res[6] = "Amount: " + reform.Inspect(s.Amount, true)
	res[7] = "Bonus: " + reform.Inspect(s.Bonus, true)
	res[8] = "Turnover: " + reform.Inspect(s.Turnover, true)
	res[9] = "UseCoupon: " + reform.Inspect(s.UseCoupon, true)
	res[10] = "CouponId: " + reform.Inspect(s.CouponId, true)
	res[11] = "UseRate: " + reform.Inspect(s.UseRate, true)
	res[12] = "RateId: " + reform.Inspect(s.RateId, true)
	res[13] = "GaCid: " + reform.Inspect(s.GaCid, true)
	res[14] = "IpAddr: " + reform.Inspect(s.IpAddr, true)
	res[15] = "IpCountry: " + reform.Inspect(s.IpCountry, true)
	res[16] = "Gateway: " + reform.Inspect(s.Gateway, true)
	res[17] = "Created: " + reform.Inspect(s.Created, true)
	res[18] = "Updated: " + reform.Inspect(s.Updated, true)
	return strings.Join(res, ", ")
}

// Values returns a slice of struct or record field values.
// Returned interface{} values are never untyped nils.
func (s *Request) Values() []interface{} {
	return []interface{}{
		s.Id,
		s.WalletId,
		s.PurseId,
		s.Type,
		s.Status,
		s.Source,
		s.Amount,
		s.Bonus,
		s.Turnover,
		s.UseCoupon,
		s.CouponId,
		s.UseRate,
		s.RateId,
		s.GaCid,
		s.IpAddr,
		s.IpCountry,
		s.Gateway,
		s.Created,
		s.Updated,
	}
}

// Pointers returns a slice of pointers to struct or record fields.
// Returned interface{} values are never untyped nils.
func (s *Request) Pointers() []interface{} {
	return []interface{}{
		&s.Id,
		&s.WalletId,
		&s.PurseId,
		&s.Type,
		&s.Status,
		&s.Source,
		&s.Amount,
		&s.Bonus,
		&s.Turnover,
		&s.UseCoupon,
		&s.CouponId,
		&s.UseRate,
		&s.RateId,
		&s.GaCid,
		&s.IpAddr,
		&s.IpCountry,
		&s.Gateway,
		&s.Created,
		&s.Updated,
	}
}

// View returns View object for that struct.
func (s *Request) View() reform.View {
	return RequestView
}

// check interfaces
var (
	_ reform.View   = RequestView
	_ reform.Struct = (*Request)(nil)
	_ fmt.Stringer  = (*Request)(nil)
)

func init() {
	parse.AssertUpToDate(&RequestView.s, new(Request))
}
